/*!
* Layout for the Palkkaus.fi reports.
* Reports are shown either as HTML in a PDF-like preview window
* OR rendered to PDF (PNG-preview) in a server-side process.
*/


/* Customize colors fonts etc. here. */

@import "default-variables/variables-reports.less";

/* Set brand logo url (.svg .png .jpg etc) */

@brand-logo-url: 'https://cdn.salaxy.com/img/palkkaus/logo/palkkaus_logo.svg';

/* Set brand logo's height (max-height is 50px). Width auto adjusts up to 40% of content area width. */

@brand-logo-height: 80px;

/* Define Google Fonts and font family base */

@family: "Roboto:300,400,500,700,400italic";
@font-family-base: Roboto,
Helvetica,
Arial,
sans-serif;

/* Import Google Fonts as defined in @family */

@import url("https://fonts.googleapis.com/css?family=@{family}");
*,
*:before,
*:after {
    -webkit-box-sizing: border-box;
    -moz-box-sizing: border-box;
    box-sizing: border-box;
}

html {
    -webkit-tap-highlight-color: rgba(0, 0, 0, 0);
}

body {
    font-family: @font-family-base;
    font-size: @font-size-base;
    line-height: @line-height-base;
    color: @text-color;
    background-color: @body-bg;
}

// -----------
// Table defaults from functional.less
table {
    width: 100%;
}

td,
th {
    vertical-align: top;
    text-align: left;
    font-size: @font-size-base;
    padding-left: 2px;
    padding-right: 2px;
}

td.text-right,
th.text-right,
td.right,
th.right {
    text-align: right;
}

tr.total td,
tr.total th {
    border-top: 1px solid black;
    border-bottom: 3px double black;
}

.valign-middle {
    vertical-align: middle !important;
}

// -----------
.salaxy-rpt {
    /* Preview layout - the document is inside .document-preview */
    .document-preview {
        background-color: Gray;
        width: 100%;
        padding: 10mm;
        min-height: 303mm;
        &.document-preview-no-height {
            padding: 2mm;
        }
        .document {
            margin-bottom: 2mm;
            #header, .header {
                border-bottom: 0.5mm solid @brand-primary;
                margin-bottom: 2mm;
                padding-bottom: 3mm;
                height: 20mm;
                #reportBrandLogo, .reportbrandlogo {
                    width: auto;
                    height: @brand-logo-height;
                    max-height: 50px;
                    background: url(@brand-logo-url);
                    background-size: contain;
                    background-repeat: no-repeat;
                }
            }
            #footer, .header {
                width: calc(100% - 20mm);
                position: absolute;
                bottom: 10mm;
                left: 10mm;
                height: 20mm;
                border-top: 0.5mm solid @brand-primary;
                padding: 2mm 0;
                font-size: 12px;
                line-height: 1.3;
            }
            #footnote, .footnote {
                font-size: 9px;
                line-height: 13px;
            }
            .document-body {
                padding-bottom: 20mm;
            }
        }
        .a4Portrait,
        .a4portrait {
            padding: 10mm;
            height: 277mm;
            /* 297 - 2 * 10 = 277 */
            width: 190mm;
            /* 210 - 2 * 10 = 190 */
        }
        .a4Portrait-no-height,
        .a4portrait-no-height {
            padding: 10mm;
            width: 190mm;
            /* 210 - 2 * 10 = 190 */
        }
        .a4Landscape,
        .a4landscape {
            padding: 10mm;
            height: 190mm;
            /* 210 - 2 * 10 = 190 */
            width: 277mm;
            /* 297 - 2 * 10 = 277 */
        }
        .a4Landscape-no-height,
        .a4landscape-no-height {
            padding: 10mm;
            width: 277mm;
            /* 297 - 2 * 10 = 277 */
        }
    }
    .document-pdf {
        .document {
            page-break-after: always;
            #footer, .footer {
                display: none;
            }
            #header, .header {
                border-bottom: 0.5mm solid @brand-primary;
                margin-bottom: 2mm;
                padding-bottom: 3mm;
                height: 20mm;
                #reportBrandLogo, .reportbrandlogo {
                    width: auto;
                    height: @brand-logo-height;
                    max-height: 50px;
                    background: url(@brand-logo-url);
                    background-size: contain;
                    background-repeat: no-repeat;
                }
            }
        }
        .a4Portrait,
        .a4portrait {
            // height: 237mm;
            height: auto;
            overflow: hidden;
            width: 190mm;
        }
        .a4Landscape,
        .a4landscape {
            // height: 190mm;
            height: auto;
            overflow: hidden;
            width: 277mm;
        }
    }
    .document {
        background-color: White;
        margin: 0px auto;
        position: relative; // If absolute positioning is used, it is in relation to document.
        font-size: @font-size-base;
        header {
            border-bottom: 0.5mm solid @brand-primary;
            padding-bottom: 3mm;
            margin-bottom: 10mm;
        }
        footer {
            width: 170mm;
            position: absolute;
            bottom: 10mm;
            left: 10mm;
            border-top: 0.5mm solid @brand-primary;
        }
        footer p,
        footer table tr td {
            font-size: 12px;
            line-height: 1.3;
        }
        h1,
        h2,
        h3 {
            margin: 0;
            font-size: 18px;
            font-weight: bold;
        }
        h1 {
            font-size: 1.3em;
        }
        h2 {
            font-size: 1.2em;
        }
        h3 {
            font-size: 1.1em;
        }
        h2.salaxy-content-subheader {
            margin: 12px 0 10px;
        }
        h3.salaxy-content-subheader {
            margin: 10px 0 5px;
        }
        p {
            margin: 5px 50px 5px 0;
        }
        &.a4Portrait,
        &.a4portrait,
        &.a4Portrait-no-height,
        &.a4portrait-no-height {
            .salaxy-accounting-report-table {
                .salaxy-accounting-report-row.salaxy-accounting-report-child-row {
                    td:nth-child(1) {
                        padding-left: 20px;
                    }
                }
            }
        }
        &.a4Landscape,
        &.a4landscape,
        &.a4Landscape-no-height,
        &.a4landscape-no-height {
            .salaxy-accounting-report-table {
                // Landscape reports have accountNo as first column
                .salaxy-accounting-report-row.salaxy-accounting-report-child-row {
                    td:nth-child(2) {
                        padding-left: 20px;
                    }
                }
            }
        }
        .salaxy-accounting-report-table {
            margin-top: 20px;
            th,
            td {
                text-align: right;
                &:first-child {
                    text-align: left;
                }
            }
            &.columns-three {
                th,
                td {
                    width: 25%;
                    &:first-child {
                        width: 50%;
                    }
                }
            }
            &.columns-three.columns-first-narrow {
                th,
                td {
                    width: 40%;
                    &:first-child {
                        width: 20%;
                    }
                }
            }
            &.columns-four {
                th,
                td {
                    width: 20%;
                    &:first-child {
                        width: 40%;
                    }
                }
            }
            &.columns-five {
                th,
                td {
                    width: 17.5%;
                    &:first-child {
                        width: 30%;
                    }
                    &:nth-child(2) {
                        // Assuming 2th column with text content
                        text-align: left;
                    }
                }
            }
            &.columns-six {
                th,
                td {
                    width: 15%;
                    &:first-child {
                        width: 25%;
                    }
                    &:nth-child(2) {
                        // Assuming 2th column with text content
                        text-align: left;
                    }
                }
            }
            &.columns-first-two-text {
                th:nth-child(1),
                th:nth-child(2),
                td:nth-child(1),
                td:nth-child(2) {
                    text-align: left !important;
                }
            }
            // thead th:first-child, tbody td:first-child {
            //     padding-left: 20px;
            // }
            // thead th:last-child, tbody td:last-child {
            //     padding-right: 20px;
            //     text-align: right;
            // }
            .salaxy-accounting-report-group-header td {
                padding-top: 6px;
                padding-bottom: 5px;
                text-transform: uppercase;
                letter-spacing: 1px;
            }
            .salaxy-accounting-report-table {
                .salaxy-accounting-report-row {
                    font-weight: bold;
                    &.salaxy-accounting-report-child-row {
                        font-weight: normal;
                    }
                }
            }
            tfoot tr.total {
                th {
                    padding-top: 10px;
                    font-weight: bold;
                    &:first-child {
                        text-transform: uppercase;
                    }
                }
            }
        }
        .table {
            width: 100%;
            max-width: 100%;
            margin-bottom: @font-size-base;
            // Cells
            thead,
            tbody,
            tfoot {
                tr {
                    th,
                    td {
                        padding: @table-cell-padding;
                        line-height: @line-height-base;
                        vertical-align: top;
                        border-top: 1px solid @table-border-color;
                    }
                }
            }
            // Bottom align for column headings
            thead tr th {
                vertical-align: bottom;
                border-bottom: 2px solid @table-border-color;
                border-top: 0px none;
            }
            // Nesting
            .table {
                background-color: @body-bg;
            }
            // Util
            .margin-top {
                margin-top: 20px;
            }
        }
        /* Tables */
        .report-table {
            border-spacing: 0;
            margin-bottom: 20px;
            margin-top: 20px;
        }
        .report-table-compact {
            border-spacing: 0;
            margin-bottom: 10px;
        }
        .report-table td,
        table td,
        table th,
        .report-table-compact td,
        .document-preview p,
        .document-preview time {
            padding: 0 5px;
            padding-left: 1px;
        }
        .report-table thead th,
        .report-table-compact th {
            font-size: 13px;
            font-weight: bold;
            padding: 0 5px 5px 0;
        }
        .report-table-separator tr td:nth-child(2) {
            border-right: 1px solid black;
            padding-right: 5px;
        }
        .report-signature-line {
            height: 25px;
            border-bottom: 1px solid black;
            margin-bottom: 8px;
        }
        .report-header-txt {
            line-height: 1.3;
            margin: 3px 0 0;
        }
        .report-section {
            min-height: 200px;
        }
        .table-condensed {
            thead,
            tbody,
            tfoot {
                tr {
                    th,
                    td {
                        padding: 1px;
                        font-size: @font-size-base;
                        line-height: normal;
                    }
                }
            }
        }
        .small {
            thead,
            tbody,
            tfoot {
                tr {
                    th,
                    td {
                        font-size: 11px;
                    }
                }
            }
        }
        .table-bordered {
            border: 1px solid @table-border-color;
            thead,
            tbody,
            tfoot {
                tr {
                    th,
                    td {
                        border: 1px solid @table-border-color;
                    }
                }
            }
            thead tr {
                th,
                td {
                    border-bottom-width: 2px;
                }
            }
        }
        .table-striped {
            tbody tr:nth-of-type(odd) {
                background-color: @table-bg-accent;
            }
        }
    }
    .watermark {
        position: absolute;
        left: 0;
        top: 40%;
        font-weight: bold;
        font-size: 20mm;
        opacity: 0.3;
        color: @brand-danger;
        text-align: center;
        width: 100%;
        transform: rotate(-45deg);
        -ms-transform: rotate(-45deg);
        /* IE 9 */
        -webkit-transform: rotate(-45deg);
        /* Opera, Chrome, and Safari */
    }
}